#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <ctype.h>

#include "list.h"

void print_list (character_list_t *str) {

  character_list_elmt_t *elem = character_list_head (str);
  for (; elem != character_list_tail (str); elem = character_list_next(elem)) {
    printf ("%c", character_list_data(elem));
  }
  printf ("%c\n", character_list_data(character_list_tail(str)));
}

bool is_anagram(character_list_t *str1, character_list_t *str2)
{

  if (character_list_size(str1) == character_list_size(str2)) {
    int t1[256];
    int t2[256];

    for (int i = 0; i < 256; i++) {
      t1[i] = 0;
      t2[i] = 0;
    }

    character_list_elmt_t *elem = character_list_head (str1);
    for (; elem != NULL; elem = character_list_next(elem)) {
      t1[(int)character_list_data(elem)]++;
    }

    elem = character_list_head (str2);
    for (; elem != NULL; elem = character_list_next(elem)) {
      t2[(int)character_list_data(elem)]++;
    }

    for (int i = 0; i < 256; i++) {
      if (t1[i] != t2[i]) {
	return false;
      }
    }

    return true;
  }

  return false;
}

int main(int argc, char **argv)
{

  character_list_t lstr1;
  character_list_init(&lstr1);

  char c = '0';
  while (fscanf(stdin, "%c", &c) != EOF) {
    if (c == '*') { break; }
    if (c != '\n')
      {
	character_list_ins_next(&lstr1, character_list_tail(&lstr1), c);
      }
  }

  character_list_t lstr2;
  character_list_init(&lstr2);
  while (fscanf(stdin, "%c", &c) != EOF)
  {
    if (c != '\n')
    {
      character_list_ins_next(&lstr2, character_list_tail(&lstr2), c);
    }
  }

  bool result = is_anagram (&lstr1, &lstr2);

  if (result) {
    printf ("OUI\n");
  }
  else {
    printf ("NON\n");
  }

  character_list_destroy(&lstr1);
  character_list_destroy(&lstr2);

  return EXIT_SUCCESS;
}
