#include <stdlib.h>
#include <stdio.h>

#include "bistree.h"
#include "bitree.h"
#include "bitreealg.h"
#include "list.h"
#include "stack.h"


int main(int argc, char **arg)
{
  integer_bistree_t tree;
  integer_bistree_init (&tree);

  int x = 0;
  while ((fscanf(stdin, "%d", &x)) != EOF)
  {
    integer_bistree_insert (&tree, x);
  }

  generic_list_t sorted_avl;
  generic_list_init (&sorted_avl, NULL, NULL, NULL);
  generic_bitreenode_t* root_avl = generic_bitree_root (&tree);
  generic_inorder (root_avl, &sorted_avl);

  integer_stack_t stack;
  integer_stack_init (&stack);

  generic_list_elmt_t* elt = generic_list_head(&sorted_avl);
  for (; elt != NULL; elt = generic_list_next(elt)) {
    integer_stack_push (&stack, ((integer_avlnode_t*)generic_list_data(elt))->data);
  }

  integer_list_elmt_t *elem = integer_list_head (&stack);
  for (; elem != NULL; elem = integer_list_next (elem)) {
    printf ("%d\n", integer_list_data (elem));
  }

  integer_bistree_destroy(&tree);
  generic_list_destroy (&sorted_avl);
  integer_stack_destroy (&stack);


  return EXIT_SUCCESS;
}
