#include <stdlib.h>
#include <stdio.h>

#include "list.h"

void check_monotony (integer_list_t *list) {

  if (integer_list_size(list) > 1) {
    integer_list_t ldelta;
    integer_list_init (&ldelta);

    integer_list_elmt_t* elem = integer_list_head (list);
    int memory = integer_list_data (elem); /* First value */
    elem = integer_list_next (elem);

    for (; elem != NULL; elem = integer_list_next (elem)) {
      int value = integer_list_data (elem);
      integer_list_ins_next (&ldelta, integer_list_tail(&ldelta), value - memory);
      memory = value;
    }

    bool cst = false;
    int acc = 0;
    elem = integer_list_head (&ldelta);
    for (; elem != NULL; elem = integer_list_next (elem)) {
      int incr = integer_list_data (elem);
      acc += incr;
      if (incr == 0) {
	cst = true;
      }
      else if ( (incr > 0 && acc < 0) || (incr < 0 && acc > 0)) {
	printf ("not monotone\n");
	integer_list_destroy (&ldelta);
	return;
      }
    }

    if (acc == 0) {
      printf ("constant\n");
    }
    else if (acc > 0) {
      if (cst == true) {
	printf ("increasing\n");
      }
      else {
	printf ("strictly increasing\n");
      }
    }
    else {
      if (cst == true) {
	printf ("decreasing\n");
      }
      else {
	printf ("strictly decreasing\n");
      }
    }

    integer_list_destroy (&ldelta);
  }
  else {
    printf ("constant\n");
  }
}


int main(void)
{
  integer_list_t list;
  integer_list_init (&list);

  int n = 0;

  while (fscanf(stdin, "%d", &n) != EOF) {
    integer_list_ins_next (&list, integer_list_tail (&list), n);
  }

  check_monotony (&list);

  integer_list_destroy (&list);

  return 0;
}
