#include <stdlib.h>
#include <stdio.h>

#include "integer_set.h"

void print_list (integer_list_t* list) {
  integer_list_elmt_t* elem = integer_list_head (list);
  for (; elem != integer_list_tail(list); elem = integer_list_next (elem)) {
    printf ("%d, ", integer_list_data (elem));
  }
  printf ("%d, ", integer_list_data (integer_list_tail(list)));
}

bool are_disjoint (integer_set_t* set1, integer_set_t* set2) {

  integer_list_elmt_t* elem = integer_list_head (set1);
  for (; elem != NULL; elem = integer_list_next (elem)) {
    int data = integer_list_data (elem);
    if (integer_set_is_member (set2, data)) {
      return false;
    }
  }

  return true;
}

int main(void) {
  int size = 0;
  fscanf(stdin, "%d", &size);

  integer_set_t *tab;
  tab = malloc (size * sizeof (integer_set_t));
  if (tab == NULL) {
    return 1;
  }

  for (int i = 0; i < size; i++) {
      integer_set_init (&(tab[i]));
  }

  int value = 0;
  int cpt = 0;
  while (fscanf (stdin, "%d", &value) != EOF) {
    if (value == 0) {
      cpt++;
    }
    else if (value != '\n') {
      integer_set_insert (&tab[cpt], value);
      }
  }

  for (int i = 0; i < size; i++) {
    for (int  j = i+1; j < size; j++) {
      if (! are_disjoint (&tab[i], &tab[j])) {
	printf ("OVERLAP\n");
	return 0;
      }
      }
  }
  printf ("DISJOINT\n");

  return 0;
}
