#include <stdlib.h>
#include <stdio.h>
#include "bitreealg.h"
#include "bitree.h"
#include "generic_queue.h"
#include "list.h"

void print_list (character_list_t *str) {
  character_list_elmt_t *elem = character_list_head (str);
  for (; elem != character_list_tail (str); elem = character_list_next(elem)) {
    printf ("%c", character_list_data(elem));
  }
  printf ("%c\n", character_list_data(character_list_tail(str)));
}

int main(void) {
  int height = 0;
  fscanf(stdin, "%d", &height);
  character_bitree_t tree;
  character_bitree_init (&tree);

  if (height > 0) {
      /* Handling root */
    char c = '0';
    fscanf (stdin, "%c", &c);
    fscanf (stdin, "%c", &c); 	/* Suppress newline */
    character_bitree_ins_left (&tree, NULL, c);

    /* Other nodes */
    generic_queue_t queue;
    generic_queue_init (&queue, NULL, NULL, NULL);
    generic_queue_enqueue (&queue, (void*) character_bitree_root (&tree));
    generic_queue_enqueue (&queue, (void*) character_bitree_root (&tree));

    int cpt = 0;
    while (fscanf (stdin, "%c", &c) != EOF) {
      if (c != '\n') {
	character_bitreenode_t *node;
	generic_queue_dequeue (&queue, (void*)&node);
	if (cpt % 2 == 0) {
	  character_bitree_ins_left (&tree, node, c);
	  generic_queue_enqueue (&queue, (void*) character_bitree_left(node));
	  generic_queue_enqueue (&queue, (void*) character_bitree_left(node));
	}
	else {
	  character_bitree_ins_right (&tree, node, c);
	  generic_queue_enqueue (&queue, (void*) character_bitree_right(node));
	  generic_queue_enqueue (&queue, (void*) character_bitree_right(node));
	}
	cpt++;
      }
    }
    generic_queue_destroy (&queue);
  }

  character_list_t lpost; character_list_init (&lpost);
  character_bitreenode_t* root = character_bitree_root (&tree);
  character_inorder (root, &lpost);

  print_list (&lpost);

  character_list_destroy (&lpost);
  character_bitree_destroy (&tree);

  return 0;
}
